/* eslint-disable no-prototype-builtins */
<template>
  <v-app>
    <div id="invoice-container" class="mx-3 pt-3">
      <v-expansion-panels multiple>
        <v-expansion-panel>
          <v-expansion-panel-header>All Invoices</v-expansion-panel-header>
          <v-expansion-panel-content>
            <div id="all-invoices-container">
              <InvoicesTable :user="user"></InvoicesTable>
            </div>
          </v-expansion-panel-content>
        </v-expansion-panel>
        <v-expansion-panel>
          <v-expansion-panel-header>Add Invoice</v-expansion-panel-header>
          <v-expansion-panel-content>
            <div class="card">
              <div class="card-body register-card-body">
                <p class="login-box-msg">
                  Please provide the information below
                </p>

                <div v-if="user.role === 'Admin'" class="input-group mb-3">
                  <select
                    type="text"
                    class="form-control"
                    v-model="selectedTrainer"
                  >
                    <option disabled value="">Trainer Name</option>
                    <option
                      v-for="trainer in trainers"
                      :value="trainer.trainerId"
                      :key="trainer.email"
                    >
                      {{ trainer.firstName + " " + trainer.lastName }}
                    </option>
                  </select>
                  <div class="input-group-append">
                    <span class="fas fa-user input-group-text"></span>
                  </div>
                </div>
                <div class="input-group mb-3">
                  <select
                    type="email"
                    class="form-control"
                    v-model="selectedClient"
                  >
                    <option disabled value="">Client Name</option>
                    <option
                      v-for="client in clients"
                      :value="client.clientId"
                      :key="client.email"
                    >
                      {{ client.firstName + " " + client.lastName }}
                    </option>
                  </select>
                  <div class="input-group-append">
                    <span class="fas fa-user input-group-text"></span>
                  </div>
                </div>
                <div class="input-group mb-3">
                  <div id="invoice-add-invoice-line-container">
                    <div id="add-invoice-line">
                      <InvoiceLine
                        v-for="(InvoiceLine, index) in invoiceLineComponents"
                        :key="InvoiceLine.index"
                        :index-value="InvoiceLine.index"
                        :displayNumber="index"
                        @invoice-line-info="getInvoiceLineInfo"
                        @delete-invoiceLine="deleteInvoice"
                        ref="index"
                      ></InvoiceLine>
                      <v-btn
                        color="secondary"
                        id="add-invoice-line-button"
                        v-on:click="addInvoiceLine()"
                        type="button"
                        class="btn btn-block btn-secondary"
                      >
                        Add Invoice Line
                      </v-btn>
                    </div>
                  </div>
                </div>

                <div class="social-auth-links text-center">
                  <v-btn
                    color="primary"
                    id="submit-invoice"
                    type="button"
                    class="btn btn-block btn-primary"
                    @click="submitInvoice"
                  >
                    Send Invoice
                  </v-btn>
                </div>
              </div>
            </div>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>
    </div>
  </v-app>
</template>

<script>
import swal from "sweetalert2";
import InvoiceLine from "../components/Invoice/InvoiceLine";
import InvoicesTable from "../components/Invoice/InvoicesTable.vue";
import moment from "moment";
import invoice from "../controllers/invoice.controller";
import trainer from "../controllers/trainer.controller";
import client from "../controllers/client.controller";
export default {
  name: "Invoices",
  components: {
    InvoiceLine,
    InvoicesTable,
  },
  data: function () {
    return {
      allInvoices: [],
      invoiceLineComponentsInfo: [],
      invoiceLineComponents: [],
      trainers: [],
      clients: [],
      selectedClient: "",
      selectedTrainer: "",
      quantity: [],
      index: 0,
      generatedInvoice: null,
    };
  },
  computed: {
    user() {
      return this.$store.getters.getAuthUser;
    },
  },
  watch: {
    selectedTrainer() {
      console.log(this.selectedTrainer);
      this.updateClients();
    },
  },
  methods: {
    addInvoiceLine() {
      let line = { InvoiceLine, index: this.index };
      this.invoiceLineComponents.push(line);
      this.invoiceLineComponentsInfo.push({ number: this.index });
      this.index++;
    },
    deleteInvoice(index) {
      swal
        .fire({
          title: "Are you sure?",
          showCancelButton: true,
          confirmButtonColor: "#3085d6",
          cancelButtonColor: "#d33",
          confirmButtonText: "Yes",
        })
        .then((result) => {
          if (result.value) {
            let actualIndex = this.invoiceLineComponents.findIndex(
              (obj) => obj.index == index
            );
            this.invoiceLineComponents.splice(actualIndex, 1);
            this.invoiceLineComponentsInfo.splice(actualIndex, 1);
          }
        });
    },
    // eslint-disable-next-line no-unused-vars
    getInvoiceLineInfo(params) {
      let index = this.invoiceLineComponentsInfo.findIndex(
        (obj) => obj.number == params.number
      );
      this.invoiceLineComponentsInfo[index] = params;
    },
    async submitInvoice() {
      if (this.selectedClient == "") {
        swal.fire("Please select a Client");
      }
      if (this.invoiceLineComponentsInfo.length == 0) {
        swal.fire("Please add an Invoice Line");
      } else {
        const failed = this.invoiceLineComponentsInfo.find(
          (line) =>
            line.price == 0 ||
            line.quantity == 0 ||
            // eslint-disable-next-line no-prototype-builtins
            !line.hasOwnProperty("price") ||
            // eslint-disable-next-line no-prototype-builtins
            !line.hasOwnProperty("quantity")
        );
        if (failed) {
          swal.fire("Invoice Lines values cannot be 0");
        } else {
          let currentDate = moment.now();
          let trainerId =
            this.user.role === "Admin"
              ? this.selectedTrainer
              : this.user.trainerId;
          let data = {
            clientId: this.selectedClient,
            //TODO: Need to add dynamic trainer ID
            trainerId: trainerId,
            issueDate: new Date(currentDate).toJSON(),
            dueDate: new Date(moment(currentDate).add(1, "M")).toJSON(),
            status: 0,
          };
          try {
            const generatedInvoice = await invoice.postInvoice(data);
            if (generatedInvoice) {
              this.generatedInvoice = generatedInvoice;
              for (const line of this.invoiceLineComponentsInfo) {
                let values = {
                  invoiceId: this.generatedInvoice.invoiceId,
                  quantity: line.quantity,
                  price: line.price,
                  description: line.description,
                };
                await invoice.postInvoiceLines(values);
              }
              const mailClient = this.clients.find(
                (client) => client.clientId == this.selectedClient
              );
              const sendMail = await invoice.sendInvoiceByMail(
                this.generatedInvoice.invoiceId,
                mailClient.email
              );
              console.log(sendMail);
              if (sendMail.status == 204) {
                swal.fire("Invoice sent");
              } else {
                swal.fire("Something went wrong");
              }
            }
          } catch (error) {
            console.log(error);
          }

          this.invoiceLineComponentsInfo = [];
          this.invoiceLineComponents = [];
        }
      }
    },
    async updateClients() {
      this.clients = await trainer.getTrainersClients(this.selectedTrainer);
    },
  },

  async mounted() {
    if (this.user.role === "Trainer") {
      this.clients = await trainer.getTrainersClients(this.user.trainerId);
    } else {
      this.clients = await (await client.getAllClients()).data;
      this.trainers = await trainer.getTrainers();
    }
  },
};
</script>

<style scoped>
#invoice-container {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}

#add-invoice-container {
  margin-left: 1em;
}
#all-invoices-container {
  margin-right: 1em;
}
</style>